/******************************************************************************
** This is a exmple of how to Get delays without library 
** 
** Warning: This code is not compatible with HAL_Delay() and also 
** with other driver libraries so do not configure el pll with 
** SystemClock_Config(CPU_CLK_160M)
******************************************************************************/
#define ms 1
#define us 0

#include <stdio.h>
#include "wm_hal.h"
#include "gpio.h"


void Error_Handler(void);


void delay(uint32_t delay_ticks,  uint8_t delay_units)
{
    TIM->CR &= ~(TIM_CR_TIM1_EN);               // turn off the timer, just in case
    TIM->TIM1_PRD = delay_ticks;                // set the delay value into the period register
	TIM->CR |= TIM_CR_TIM1_MODE;                // counting mode - single
    TIM->CR &= ~(TIM_CR_TIM1_UNIT_Msk); // reset units of account
    TIM->CR |= delay_units << TIM_CR_TIM1_UNIT_Pos;     // set units of account
    TIM->CR |= TIM_CR_TIM1_EN;                  // turn on the timer
    while(!(TIM->CR & TIM_CR_TIM1_TIF));
}

int main(void)
{

 
  HAL_Init();
  GPIO_Init();

  
    while (1) {
		
      delay(200,ms);
      HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_0);
	  delay(200,ms);
      HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_1);
      delay(200,ms);
      HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_2); 
    }
}


void Error_Handler(void)
{
   while (1){
  }
} 

void assert_failed(uint8_t *file, uint32_t line)
{
    printf("Wrong parameters value: file %s on line %d\r\n", file, line);
}